'use strict';

Object.defineProperty(exports, "__esModule", {
    value: true
});

var _orderBy2 = require('lodash/orderBy');

var _orderBy3 = _interopRequireDefault(_orderBy2);

var _filter2 = require('lodash/filter');

var _filter3 = _interopRequireDefault(_filter2);

var _forEach2 = require('lodash/forEach');

var _forEach3 = _interopRequireDefault(_forEach2);

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _toConsumableArray(arr) { if (Array.isArray(arr)) { for (var i = 0, arr2 = Array(arr.length); i < arr.length; i++) { arr2[i] = arr[i]; } return arr2; } else { return Array.from(arr); } }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

exports.default = function (WrappedComponent) {
    var _class, _temp2;

    return _temp2 = _class = function (_Component) {
        _inherits(_class, _Component);

        function _class() {
            var _ref;

            var _temp, _this, _ret;

            _classCallCheck(this, _class);

            for (var _len = arguments.length, args = Array(_len), _key = 0; _key < _len; _key++) {
                args[_key] = arguments[_key];
            }

            return _ret = (_temp = (_this = _possibleConstructorReturn(this, (_ref = _class.__proto__ || Object.getPrototypeOf(_class)).call.apply(_ref, [this].concat(args))), _this), _this.unSubscribe = null, _this.state = { requests: null }, _this.oldState = null, _this.traces = [], _this.handleStoreUpdate = function () {
                var store = _this.context.store;

                var state = store.getState();

                if (!_this.oldState || _this.oldState.requests !== state.requests) {
                    _this.setState({
                        requests: state.requests
                    });
                }

                (0, _forEach3.default)(_this.traces, function (_ref2) {
                    var cb = _ref2.cb;
                    return cb(state);
                });
                _this.oldState = state;
            }, _this.trace = function (id) {
                return new Promise(function (resolve, reject) {
                    _this.traces.push({
                        id: id,
                        cb: function cb(state) {
                            if (!_this.oldState || state.requests !== _this.oldState.requests) {
                                var request = state.requests[id];

                                var unSubscribe = function unSubscribe() {
                                    return _this.traces = [].concat(_toConsumableArray((0, _filter3.default)(_this.traces, function (tracer) {
                                        return tracer.id !== id;
                                    })));
                                };

                                if (request.status == "complete") {
                                    unSubscribe();
                                    resolve();
                                } else if (request.status == "failed") {
                                    unSubscribe();
                                    reject(request.error);
                                }
                            }
                        }
                    });
                });
            }, _this.getRequestTools = function () {
                var store = _this.context.store;

                var composeRequestQuery = function composeRequestQuery(check) {
                    return function (requestString, resolve, reject) {
                        var result = check(requestString);
                        var format = function format(data, other) {
                            if (typeof resolve === 'undefined' && typeof reject === 'undefined') return other;
                            return typeof data === 'function' ? data() : typeof data === 'undefined' ? null : data;
                        };

                        if (result) return format(resolve, true);
                        return format(reject, false);
                    };
                };

                var getRequest = function getRequest(func) {
                    return function (idOrName) {
                        var _store$getState = store.getState(),
                            requests = _store$getState.requests;

                        var request = requests[idOrName];

                        /* The given prop did not match a requestId so the next step is
                         * to find the last request made containing the given name. The age
                         * of the request is determined by a timestamp set by the reducer.
                         * */
                        if (!request) {
                            var filteredRequests = (0, _filter3.default)(requests, function (_ref3) {
                                var name = _ref3.name;
                                return name == idOrName;
                            });
                            if (filteredRequests.length) {
                                request = (0, _orderBy3.default)(filteredRequests, ['timestamp'], ['desc'])[0];
                            }
                        }
                        return func(request);
                    };
                };

                return {
                    complete: composeRequestQuery(getRequest(function (request) {
                        return request && (request.status == "complete" || request.status == "failed");
                    })),
                    successful: composeRequestQuery(getRequest(function (request) {
                        return request && request.status == "complete";
                    })),
                    failed: composeRequestQuery(getRequest(function (request) {
                        return request && request.status == "failed";
                    })),
                    pending: composeRequestQuery(getRequest(function (request) {
                        return request && request.status == "pending";
                    })),

                    trace: _this.trace
                };
            }, _temp), _possibleConstructorReturn(_this, _ret);
        }

        _createClass(_class, [{
            key: 'componentWillMount',
            value: function componentWillMount() {
                this.unSubscribe = this.context.store.subscribe(this.handleStoreUpdate);
            }
        }, {
            key: 'componentWillUnmount',
            value: function componentWillUnmount() {
                if (typeof this.unSubscribe === 'function') this.unSubscribe();
            }
        }, {
            key: 'render',
            value: function render() {
                return _react2.default.createElement(WrappedComponent, _extends({}, this.props, { requests: this.state.requests }, this.getRequestTools()));
            }
        }]);

        return _class;
    }(_react.Component), _class.contextTypes = {
        store: _react.PropTypes.object
    }, _temp2;
};